/*

This file only has a main function
Include KVClientLibrary.c to use interfaces to make GET, PUT, DELETE requests

PA4 instructions:
The client is a separate process that will first establish a connection with the server, and then
send GET , PUT , and DELETE requests to the server process. It will have a main and use the
client library interfaces to do the actual operations.

*/
#include <stdio.h> 
#include <netdb.h> 
#include <netinet/in.h> 
#include <stdlib.h> 
#include <string.h> 
#include <unistd.h>
#include <sys/socket.h> 
#include <sys/types.h> 
#include "KVMessageFormat.h"
#include <arpa/inet.h>
#define MAX 80 
#define PORT 8000 
#define SA struct sockaddr 
struct message *request(char status,char* key,char* value)
{
      if(!status ||(key==NULL && value==NULL) )
    {
        printf("Invalid parameters in request()");
        return NULL;
    }
    struct message *requestMessage= malloc(sizeof(struct message));
    requestMessage->status=status;

    memcpy(requestMessage->key,key,256); //copied the complete key

    if(strlen(requestMessage->key)<256)
    {
        requestMessage->key[strlen(requestMessage->key)]='\0';
    }
    if(value!=NULL)
    {
        memcpy(requestMessage->value,value,256); //copied the complete value
    }
   
    if(strlen(requestMessage->value)<256) //to pad with \0
    {
        requestMessage->value[strlen(requestMessage->value)]='\0';
    }
    printf("[Message Generated at Client]\n[[Status:%c]\n[Key:%s]\n[Value:%s]]",requestMessage->status,requestMessage->key,requestMessage->value);
    return requestMessage;
}
 struct message* requestMessage;
void func(int sockfd,struct message* requestMessage) 
{ 
    char buff[MAX]; 
    int n; 
    for (;;) { 
        bzero(buff, sizeof(buff)); 
        n = 0; 
        if((n++)==0)
            write(sockfd, requestMessage, sizeof(struct message)); 
        //printf("[Message sent to server]\n[[Status:%c]\n[Key:%s]\n[Value:%s]]",requestMessage->status,requestMessage->key,requestMessage->value);
        
    } 
} 
int main(int argc, char const *argv[]) 
{ 
    int sock = 0, valread; 
    struct sockaddr_in serv_addr; 
    char *hello = "Hello from client"; 
    char buffer[1024] = {0}; 
    if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0) 
    { 
        printf("\n Socket creation error \n"); 
        return -1; 
    } 
   
    serv_addr.sin_family = AF_INET; 
    serv_addr.sin_port = htons(PORT); 
       
    // Convert IPv4 and IPv6 addresses from text to binary form 
    if(inet_pton(AF_INET, "127.0.0.1", &serv_addr.sin_addr)<=0)  
    { 
        printf("\nInvalid address/ Address not supported \n"); 
        return -1; 
    } 
   
    if (connect(sock, (struct sockaddr *)&serv_addr, sizeof(serv_addr)) < 0) 
    { 
        printf("\nConnection Failed \n"); 
        return -1; 
    } 
    char key[256]="abc";
    char value[256]="cde";
    struct message *requestMessage= request('g',key,value);
    struct message *replyMessage=malloc(sizeof(struct message));
    ///send(sock , requestMessage ,sizeof(struct message) , 0 ); 
    ///printf("Hello message sent\n"); 
    func(sock,requestMessage);
   // valread = read( sock , replyMessage, sizeof(struct message)); 
    //printf("[Message Received from client]\n[[Status:%c]\n[Key:%s]\n[Value:%s]]",replyMessage->status,replyMessage->key,replyMessage->value);

    return 0; 
} 